# How to create a wallet using cardano-cli

## To create a wallet, we will use three commands.

In this lesson, we will focus on each of these commands:

1. `cardano-cli address key-gen` creates a public key and a private key
2. `cardano-cli stake-address key-gen` creates a public staking key and a private staking key
3. `cardano-cli address build` generates a Cardano Address

Each command will generate some new files. So, before getting started, create a new directory to save these files. For example, in our `/PPBL2023/` directory:

```bash
 mkdir my-new-wallet
 cd my-new-wallet
```

## <br />

## 1. cardano-cli address key-gen

Use `cardano-cli address key-gen` to generate a new pair of key files:

- The `verification-key-file`, also known as a **public key**
- The `signing-key-file` also known as a **private key**

To generate a pair of key files, use this command:

```bash
cardano-cli address key-gen --verification-key-file payment.vkey --signing-key-file payment.skey
```

The file names `payment.vkey` and `payment.skey` can be whatever you want. However, these are the customary file names.

### Important: Private Keys are JUST LIKE mnemonics

You must protect your `signing-key-file` (in this case, `payment.skey`) just like you protect your mnemonic words because you will use them to unlock your tokens.

The `verification-key-file` (in this case, `payment.vkey`) is public, and you can share it with anyone, just like a wallet address.

## <br />

## 2. cardano-cli stake-address key-gen

A different pair of key files are used to create staking credentials, like this:

```bash
cardano-cli stake-address key-gen --verification-key-file stake.vkey --signing-key-file stake.skey
```

Here, the private key file `stake.skey` is used to sign transactions that involve stake registration.

You can build a wallet address with or without staking credentials.

## <br />

## 3. cardano-cli address build

You can generate a cardano address from a public key file like this:

```bash
cardano-cli address build \
--payment-verification-key-file payment.vkey \
--stake-verification-key-file stake.vkey \
--out-file payment.addr --testnet-magic 1
```

You can use the same verification key to create addresses on different networks. Above, we used `--testnet-magic 1` because we are using Preprod. Instead, look at what happens when you try this:

```bash
cardano-cli address build \
--payment-verification-key-file payment.vkey \
--stake-verification-key-file stake.vkey \
--out-file payment.addr --mainnet
```

You can also build addresses without staking credentials, like this:

```bash
cardano-cli address build \
--payment-verification-key-file payment.vkey \
--out-file payment.addr --testnet-magic 1
```

## <br />

## Putting it all together, we have:

```bash
cardano-cli address key-gen \
--verification-key-file payment.vkey \
--signing-key-file payment.skey

cardano-cli stake-address key-gen \
--verification-key-file stake.vkey \
--signing-key-file stake.skey

cardano-cli address build \
--payment-verification-key-file payment.vkey \
--stake-verification-key-file stake.vkey \
--out-file payment.addr \
--testnet-magic 1
```

In Lesson 102.6, you will look at a bash script that automates this process.

## <br />

# How to Build a Contract Address

In [Lesson 101.2](/modules/101/1012), you heard that you could derive contract addresses from Plutus scripts. Here is how.

We replace the verification key file with a `payment-script-file` to build an address from the Plutus script. The file can be a Plutus script.

```bash
cardano-cli address build --testnet-magic 1 --payment-script-file always-succeeds.plutus
```

## Examples:

**Example Output: PlutusTx**

```bash
$ cardano-cli address build --testnet-magic 1 --payment-script-file always-succeeds-plutusTx.plutus
addr_test1wqag3rt979nep9g2wtdwu8mr4gz6m4kjdpp5zp705km8wys6t2kla
```

This address [has a history on Cardanoscan](https://preprod.cardanoscan.io/address/addr_test1wqag3rt979nep9g2wtdwu8mr4gz6m4kjdpp5zp705km8wys6t2kla)!

**Example Output: Aiken**

```bash
$ cardano-cli address build --testnet-magic 1 --payment-script-file always-succeeds-aiken.plutus
addr_test1wzd7s978pzla9qdwjshnme9wvlwfrrajzwcztpay7uynx9qalqts7
```

This address [has a history on Cardanoscan](https://preprod.cardanoscan.io/address/addr_test1wzd7s978pzla9qdwjshnme9wvlwfrrajzwcztpay7uynx9qalqts7)!

**Example Output: plu-ts**

```bash
$ cardano-cli address build --testnet-magic 1 --payment-script-file always-succeeds-plu-ts.plutus
addr_test1wr5vjne65nh3zfp9ndf6xnk02uxkzlsdtczsu7pxw8gatuqzdca8z
```

As of the start of this course, this address [has no history on Cardanoscan](https://preprod.cardanoscan.io/address/addr_test1wr5vjne65nh3zfp9ndf6xnk02uxkzlsdtczsu7pxw8gatuqzdca8z)

We will use these contract addresses in Lessons [102.4](/modules/102/1024) and [102.5](/modules/102/1025).

## <br />

## Keep Exploring:

You can learn about any `cardano-cli` command by entering it in your terminal. For example:

```bash
$ cardano-cli address key-gen
Usage: cardano-cli address key-gen [--normal-key | --extended-key | --byron-key]
            --verification-key-file FILE
            --signing-key-file FILE

  Create an address key pair.

Available options:
  --normal-key             Use a normal Shelley-era key (default).
  --extended-key           Use an extended ed25519 Shelley-era key.
  --byron-key              Use a Byron-era key.
  --verification-key-file FILE
                           Output filepath of the verification key.
  --signing-key-file FILE  Output filepath of the signing key.
  -h,--help                Show this help text

```

To see more examples, watch the video above.

## <br />

## What's Next?

- In Lesson 102.3, we will send transactions to and from your new wallet address.
- In Lessons 102.4 and 102.5, we will build our first transactions using the contract addresses above.

import MDXLessonLayout from '@/src/components/lms/Lesson/MDXLessonLayout.tsx';
export default ({ children }) => <MDXLessonLayout>{children}</MDXLessonLayout>;
